<?php
/**
 * Created by PhpStorm.
 * User: nmatuschek
 * Date: 12.12.17
 * Time: 08:47
 */

class ilFatImageMapQuestionAdapter extends assImagemapQuestion
{
    public function saveWorkingData($active_id, $pass = null, $authorized = true)
    {
        global $DIC;
        $ilDB = $DIC->database();
        
        if (is_null($pass)) {
            $pass = ilObjTest::_getPass($active_id);
        }
        
        $solutionSelectionChanged = false;
        
        $this->getProcessLocker()->executeUserSolutionUpdateLockOperation(function () use (&$solutionSelectionChanged, $ilDB, $active_id, $pass, $authorized) {
            if ($this->isRemoveSolutionSelectionRequest()) {
                $selection = $this->getRemoveSolutionSelectionParameter();
                if (strlen($selection) > 0) {
                    $this->deleteSolutionRecordByValues($active_id, $pass, !$authorized, array(
                        'value1' => (int) $selection
                    ));
                    $this->deleteSolutionRecordByValues($active_id, $pass, $authorized, array(
                        'value1' => (int) $selection
                    ));
                    
                    $solutionSelectionChanged = true;
                }
            } elseif ($this->isAddSolutionSelectionRequest()) {
                $selection = $this->getAddSolutionSelectionParameter();
                if (strlen($selection) > 0) {
                    if ($this->is_multiple_choice) {
                        $this->deleteSolutionRecordByValues($active_id, $pass, !$authorized, array(
                            'value1' => (int) $selection
                        ));
                        $this->deleteSolutionRecordByValues($active_id, $pass, $authorized, array(
                            'value1' => (int) $selection
                        ));
                    } else {
                        $this->removeCurrentSolution($active_id, $pass, !$authorized);
                        $this->removeCurrentSolution($active_id, $pass, $authorized);
                    }

                    $this->saveCurrentSolution($active_id, $pass, (int) $selection, null, !$authorized);
                    $this->saveCurrentSolution($active_id, $pass, (int) $selection, null, $authorized);

                    $solutionSelectionChanged = true;
                }
            }
        });
        
        if (ilObjAssessmentFolder::_enabledAssessmentLogging()) {
            if ($solutionSelectionChanged) {
                assQuestion::logAction($this->lng->txtlng("assessment", "log_user_entered_values", ilObjAssessmentFolder::_getLogLanguage()), $active_id, $this->getId());
            } else {
                assQuestion::logAction($this->lng->txtlng("assessment", "log_user_not_entered_values", ilObjAssessmentFolder::_getLogLanguage()), $active_id, $this->getId());
            }
        }
        
        return true;
    }
    
    public function removeIntermediateSolution($active_id, $pass)
    {
    }
}
