<?php

/**
 * Class ilFormATestHistoryGUI
 */
class ilFormATestHistoryGUI extends ilXTSFControllerGUI
{
    /**
     * @param ilObjFormATestGUI $controller
     */
    public function __construct(ilObjFormATestGUI $controller)
    {
        parent::__construct($controller);
    }

    public function showHistory()
    {
        $this->controller->ensurePermission('write');

        $table = new ilTestHistoryTableGUI($this->controller, __CLASS__ . '.showHistory');
        $table->setTestObject($this->controller->object);

        $log = ilObjAssessmentFolder::_getLog(0, time(), $this->controller->object->getId(), true);
        foreach ($log as $row_idx => $data) {
            foreach ($data as $key => $val) {
                if ('href' == $key && strpos($val, 'tst_') !== false) {
                    $log[$row_idx][$key] = str_replace('tst_', 'xtsf_', $val);
                }
            }
        }
        $table->setData($log);
        $this->tpl->setContent($table->getHTML());
    }

    /**
     * Returns the current tab name
     * return string
     */
    protected function getCurrentTab()
    {
        return 'history';
    }

    /**
     * @return array
     */
    protected function getRequirements()
    {
    }
}
